-- Run configure scripts after package installs, upgrades, degrades and removals
-- By rbos@users.sourceforge.net
-- Licenced under the GPL

if transaction_success == false then
	return
end

if confexists("Scripts::Options::ShowRpmCmd") and
  confget("Scripts::Options::ShowRpmCmd/b") == "true" then
	return
end

if not confexists("Scripts::Options::RunPostScript") or
  confget("Scripts::Options::RunPostScript/b") == "false" then
	return
end

if confexists("System::Post::") then
	POSTSCRIPT = confget("System::Post::")
else
	-- Default postscript
	POSTSCRIPT = "/sbin/SuSEconfig"
end

-- don't log when in --test mode
configs = { "RPM::Options", "RPM::Install-Options", "RPM::Erase-Options" }
for i, conf in ipairs(configs) do
	rpmopts = confgetlist(conf, "")
	for j, opt in ipairs(rpmopts) do
		if string.find(opt, "test") then
			print( "apt running in test mode: "..POSTSCRIPT.." would now be executed")
			return
		end
	end
end

print("apt executing: "..POSTSCRIPT)
os.execute( POSTSCRIPT )

LDCONFIG = "/sbin/ldconfig"
print("apt executing: "..LDCONFIG)
os.execute( LDCONFIG )

